"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AjaxFactory_1 = require("web-angularjs-user-factory/AjaxFactory");
var factory_1 = require("../list/factory");
var BasicItemService = (function () {
    function BasicItemService(ajaxFactory, listFactory, apiUrl) {
        this.ajaxFactory = ajaxFactory;
        this.listFactory = listFactory;
        this.apiUrl = apiUrl;
        this.mode = 'router';
    }
    BasicItemService.prototype.getMode = function (controller) {
        if (controller.id !== undefined) {
            return this.mode = 'event';
        }
        else {
            return this.mode = 'router';
        }
    };
    BasicItemService.prototype.$get = function () {
        return this;
    };
    BasicItemService.prototype.getItem = function (id, cb, failCB) {
        if (id === undefined || id.indexOf('placeholder') !== -1) {
            return cb({});
        }
        this.ajaxFactory.httpServerCall(this.apiUrl + '/' + id, 'get', undefined, function (data) {
            if (data && data && (data.length || !data.error)) {
                cb && cb(data);
            }
            else {
                failCB && failCB(data);
            }
        });
    };
    ;
    BasicItemService.prototype.saveItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        this.ajaxFactory.httpServerCall(this.apiUrl, 'PUT', item, function (response) {
            if (response || response.error)
                return failCB && failCB(response);
            _this.listFactory.AddedItem();
            if (response.length)
                item = response[0];
            else
                item = response;
            cb && cb(item);
        }, function () {
            failCB && failCB(undefined);
        });
    };
    ;
    BasicItemService.prototype.deleteItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        if (!item || !item.id)
            return failCB && failCB(undefined);
        this.ajaxFactory.httpServerCall(this.apiUrl + '/' + item.id, 'DELETE', item, function (response) {
            if (response.error)
                return failCB && failCB(response);
            _this.listFactory.AddedItem();
            item = undefined;
            cb && cb();
        }, function () {
            failCB && failCB(undefined);
        });
    };
    ;
    BasicItemService.prototype.createItem = function (item, cb, failCB) {
        var _this = this;
        if (failCB === void 0) { failCB = undefined; }
        this.ajaxFactory.httpServerCall(this.apiUrl, 'POST', item, function (response) {
            if (response.error)
                return failCB && failCB(response);
            _this.listFactory.AddedItem();
            if (response.length)
                item = response[0];
            else
                item = response;
            cb && cb(item);
        }, function (error) {
            failCB && failCB(error);
        });
    };
    ;
    BasicItemService.BasicItemService = function () {
        return [AjaxFactory_1.AjaxFactoryModule.factoryName,
            factory_1.BasicListFactory.factoryName, function (uf, blf) {
                return new BasicItemService(uf, blf, '/api/item');
            }];
    };
    BasicItemService.prototype.getId = function (controller, $stateParams) {
        if (this.mode === 'router') {
            return $stateParams.id;
        }
        else {
            return controller.id;
        }
    };
    return BasicItemService;
}());
BasicItemService.serviceName = 'basicItemItemService';
BasicItemService.$inject = [
    AjaxFactory_1.AjaxFactory.factoryName,
    factory_1.BasicListFactory.factoryName
];
exports.BasicItemService = BasicItemService;
BasicItemService.$inject.push(BasicItemService);
//# sourceMappingURL=service.js.map